%{
#include "algol.h"
%}

%term LEFT_PAREN BEGIN_SYM
%term PROCEDURE INDEX LENGTH ENDSTRUCTURE AND ARRAY BOOLEAN CASE DO
%term ELSE END_SYM ENDCASE EXTERNAL FALSE FOR FUNCTION GO GOTO IF
%term INTEGER LITERAL NOT OR OWN POINTER REAL RETURN STEP STRING
%term STRUCTURE SUBSTRING TO THEN TRUE TYPE UNION UNTIL WHILE
%term ARROW COLON COMMA CONCAT LONG SEMICOLON LEFT_MARK RIGHT_MARK
%term RIGHT_PAREN ATSIGN QUOTEQUOTE STARSTAR ADD_OP MUL_OP REL_OP
%term LOG_OP ID NAMED_VAR NAMED_BOOL NAMED_PTR NAMED_LABEL NAMED_STRING
%term FUNCTION_ID BOOLEAN_ID PROC_ID STRING_ID NAMED_STRUCT USER_TYPE
%term STRING_CONSTANT NUMERIC_CONSTANT COMMENT

%%

algol : PROG
;
PROG : block semi_list
;
block : block_head end_part
;
block_head : BEGIN_SYM
;
end_part : declare_list semi_list stmt_list semi_list block_end
 | stmt_list semi_list block_end
;
end_part : block_end
;
declare_list : declare_list semi_list declare_stmt
| declare_stmt
;
declare_stmt : storage_type data_type id_list
| data_type id_list
;
declare_stmt : storage_type data_type ARRAY ID LEFT_MARK expression RIGHT_MARK
| data_type ARRAY ID LEFT_MARK expression RIGHT_MARK
;
semi_list : semi_list SEMICOLON
 | SEMICOLON
;
block_end : END_SYM
;
data_type : BOOLEAN
| INTEGER
| POINTER
| REAL
| STRING
| structure_type
| user_declare
| LONG
;
storage_type : OWN
| EXTERNAL
;
id_list : id_list COMMA ID
| ID
;
structure_type : structure_define END_SYM
;
structure_define : STRUCTURE ID LEFT_MARK declare_list
;
stmt_list : stmt_list semi_list stmt
| stmt
;
user_declare : TYPE data_type ID 
;
stmt : any_stmt
| if_stmt
| for_stmt
;
any_stmt :  goto_stmt
| while_stmt
| until_stmt
| assign_stmt
| string_stmt
| case_stmt
| block
| return_stmt
;
if_stmt : IF bool_part then_part else_part
  | IF bool_part boolean_expr then_part
;
bool_part : LEFT_PAREN boolean_expr
;
then_part : RIGHT_PAREN THEN stmt
           | RIGHT_PAREN THEN;
else_part : ELSE stmt
| ELSE
;
for_stmt : FOR step_part step_part_2 DO stmt
;
step_part : NAMED_VAR ARROW expression STEP
;
step_part_2 : expression UNTIL expression
;
goto_stmt : GOTO NAMED_LABEL
 | GO TO NAMED_LABEL
;
while_stmt : WHILE bool_part RIGHT_PAREN DO stmt
;
until_stmt : UNTIL bool_part RIGHT_PAREN DO stmt
;
assign_stmt : NAMED_VAR ARROW expression
;
| NAMED_BOOL ARROW boolean_expr
| NAMED_BOOL ARROW expression
;
string_stmt : NAMED_STRING ARROW string_val
;
| substring_proc ARROW string_val
;
string_val : expression CONCAT NAMED_STRING
| string_val CONCAT expression
| string_val CONCAT NAMED_STRING
| string_val CONCAT string_function
| QUOTEQUOTE
| STRING_CONSTANT
| NAMED_STRING
| string_function
| substring_proc
;
substring_proc : SUBSTRING LEFT_PAREN NAMED_STRING COMMA expression COMMA expression RIGHT_PAREN
;
string_function : INDEX LEFT_PAREN string_val COMMA string_val RIGHT_PAREN
| LENGTH LEFT_PAREN string_val RIGHT_PAREN
;
arg_list : arg_list COMMA expression
| expression
;
return_stmt : RETURN
| RETURN any_value 
;
arithmetic_case : CASE variable COLON arith_cases ENDCASE
;
any_value : boolean_expr
| NAMED_STRUCT
| expression
| string_val
| NAMED_PTR
| string_case
| arithmetic_case
;
string_case : CASE string_val COLON string_cases ENDCASE
| string_val COLON any_stmt SEMICOLON;
;
string_cases : string_cases string_case
| string_case
;
arith_cases : arith_cases arith_case
;
| arith_case
;
arith_case : expression COLON any_stmt SEMICOLON
;
case_stmt : string_case
          | arithmetic_case
;
expression : expression ADD_OP expression
| expression MUL_OP expression
| ADD_OP expression
| variable
;
expression : variable power_list
;
variable : LEFT_PAREN expression RIGHT_PAREN
| NUMERIC_CONSTANT
| function_call
| NAMED_VAR
| ATSIGN NAMED_PTR
power_list : power_list STARSTAR variable
| STARSTAR variable
;
function_call : FUNCTION_ID LEFT_PAREN arg_list RIGHT_PAREN
| FUNCTION_ID LEFT_PAREN RIGHT_PAREN
;
boolean_expr : boolean_expr OR boolean_expr
| boolean_expr AND boolean_expr
| boolean_expr LOG_OP boolean_expr
| boolean_expr REL_OP boolean_expr
| notted_boolean
;
notted_boolean : NOT notted_boolean
| boolean_var
;
boolean_var : TRUE
| FALSE
| NAMED_BOOL
| BOOLEAN_ID LEFT_PAREN arg_list RIGHT_PAREN
| BOOLEAN_ID LEFT_PAREN RIGHT_PAREN
| LEFT_PAREN boolean_expr RIGHT_PAREN;


%%
